#pragma once

#include "DitGlassRawStruct.h"
#include <afxmt.h>

class CDitGlassRawClient
{
public:
	CDitGlassRawClient(void);
	~CDitGlassRawClient(void);
	
public:
	static CDitGlassRawClient* GetInstance(); //cmark

	BOOL ConnectServer();
	BOOL isConnect(){return m_hMapBasicInfo == NULL || m_hMapGlassData == NULL ? FALSE : TRUE;};

	emAOIProcStep GetProcessStep();

	BOOL SetGlassLoading();
	BOOL SetInspectEnd();

	BOOL SetReviewStart();
	BOOL SetReviewEnd();

	BOOL SetReviewComtomize();

	void RemoveReviewDefects();//AOI    ϰ, 信  User Ȥ Reflow  Ѵ.

	_grmDitMemInfo*	GetGlassMeminfo(){return (_grmDitMemInfo*)m_pGlassRawInfo;};
	_grmGlassData*	GetGlassData(){return m_pGlassData;};
	_grmBlockData*		GetBlockData(){return m_pBlockData;};
	_grmCellData*	GetCellData(int nIndex){return &m_pCellData[nIndex];};
	_grmDefectData*	GetDefectData(int nIndex){return &m_pDefectData[nIndex];};

	//     [ 2018/11/12]
	BOOL WriteAOIRawFile();

	//  ̳ʸ ·  [ 2018/11/12]
	BOOL WriteAOIRawBinFile(); 

	//  ̳ʸ б 
	BOOL ReadAOIRawBinFile();

protected:
	BOOL ConnectGlassRawInfo();
	BOOL ConnectGlassRawData();
	BOOL SetCommand(emGlassRawCommand nCmd);
	
	static CDitGlassRawClient* m_pDitGlassClient; //cmark
protected:
//	_grmHederData*		m_pHederData;
	_grmGlassData*  m_pGlassData;
	_grmBlockData*		m_pBlockData;
	_grmCellData*   m_pCellData;
	_grmDefectData* m_pDefectData;
	

protected:
	
	HANDLE		m_hMapBasicInfo;
	HANDLE		m_hMapGlassData;
	_grmDitGlassRawInfo* m_pGlassRawInfo;
	char*		m_pGlassRawData;

	CMutex		m_mxCommandProcess;
	int			m_nLastCommandIdx;

};
